"""wgweb URL Configuration
The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import path,include
from rest_framework import routers
from wg_api import views

router = routers.DefaultRouter()
router.register(r'wgAPI', views.wgView, 'wg_api')

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include(router.urls)),
    path('api2/wgLogin', views.wgLogin.as_view()),
    path('api2/wgLogs', views.wgViewLogs),
    path('api2/wgClients', views.wgViewClients),
    path('api2/wgFilterClients', views.wgFilterClients),
    path('api2/wgEditState', views.get_EditState),
    path('api2/wgSysApply', views.get_ApplyConfig),
    path('api2/wgBulkReg', views.wgBulkReg),
    path('api2/wgUserRecommendations', views.get_user_param_recommendation),
    path('api2/wgCheckAuth', views.wgCheckAuth),
    path('api2/wgEditClient', views.get_EditClient),
    path('api2/wgDelClient', views.wg_DelClient),
    path('api2/wgGetClient', views.wg_GetClient),
    path('api2/wgGetGraphData', views.wg_GetGraphData)
]
